# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudaccountsnsxtIdBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'host_name': 'str',
        'dcid': 'str',
        'username': 'str',
        'password': 'str',
        'associated_cloud_account_ids': 'list[str]',
        'accept_self_signed_certificate': 'bool',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'certificate_info': 'IaasapiintegrationsCertificateInfo'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'host_name': 'hostName',
        'dcid': 'dcid',
        'username': 'username',
        'password': 'password',
        'associated_cloud_account_ids': 'associatedCloudAccountIds',
        'accept_self_signed_certificate': 'acceptSelfSignedCertificate',
        'tags': 'tags',
        'certificate_info': 'certificateInfo'
    }

    def __init__(self, name=None, description=None, host_name=None, dcid=None, username=None, password=None, associated_cloud_account_ids=None, accept_self_signed_certificate=None, tags=None, certificate_info=None):  # noqa: E501
        """CloudaccountsnsxtIdBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._host_name = None
        self._dcid = None
        self._username = None
        self._password = None
        self._associated_cloud_account_ids = None
        self._accept_self_signed_certificate = None
        self._tags = None
        self._certificate_info = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.host_name = host_name
        self.dcid = dcid
        self.username = username
        self.password = password
        if associated_cloud_account_ids is not None:
            self.associated_cloud_account_ids = associated_cloud_account_ids
        if accept_self_signed_certificate is not None:
            self.accept_self_signed_certificate = accept_self_signed_certificate
        if tags is not None:
            self.tags = tags
        if certificate_info is not None:
            self.certificate_info = certificate_info

    @property
    def name(self):
        """Gets the name of this CloudaccountsnsxtIdBody.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudaccountsnsxtIdBody.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this CloudaccountsnsxtIdBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CloudaccountsnsxtIdBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def host_name(self):
        """Gets the host_name of this CloudaccountsnsxtIdBody.  # noqa: E501

        Host name for the NSX-T endpoint  # noqa: E501

        :return: The host_name of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this CloudaccountsnsxtIdBody.

        Host name for the NSX-T endpoint  # noqa: E501

        :param host_name: The host_name of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """
        if host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def dcid(self):
        """Gets the dcid of this CloudaccountsnsxtIdBody.  # noqa: E501

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release and hence the data collector Id is optional for VMware Aria Automation (on-prem).  # noqa: E501

        :return: The dcid of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._dcid

    @dcid.setter
    def dcid(self, dcid):
        """Sets the dcid of this CloudaccountsnsxtIdBody.

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release and hence the data collector Id is optional for VMware Aria Automation (on-prem).  # noqa: E501

        :param dcid: The dcid of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """
        if dcid is None:
            raise ValueError("Invalid value for `dcid`, must not be `None`")  # noqa: E501

        self._dcid = dcid

    @property
    def username(self):
        """Gets the username of this CloudaccountsnsxtIdBody.  # noqa: E501

        Username to authenticate with the cloud account  # noqa: E501

        :return: The username of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CloudaccountsnsxtIdBody.

        Username to authenticate with the cloud account  # noqa: E501

        :param username: The username of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this CloudaccountsnsxtIdBody.  # noqa: E501

        Password for the user used to authenticate with the cloud Account  # noqa: E501

        :return: The password of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CloudaccountsnsxtIdBody.

        Password for the user used to authenticate with the cloud Account  # noqa: E501

        :param password: The password of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: str
        """
        if password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def associated_cloud_account_ids(self):
        """Gets the associated_cloud_account_ids of this CloudaccountsnsxtIdBody.  # noqa: E501

        vSphere cloud accounts associated with this NSX-T cloud account.  # noqa: E501

        :return: The associated_cloud_account_ids of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._associated_cloud_account_ids

    @associated_cloud_account_ids.setter
    def associated_cloud_account_ids(self, associated_cloud_account_ids):
        """Sets the associated_cloud_account_ids of this CloudaccountsnsxtIdBody.

        vSphere cloud accounts associated with this NSX-T cloud account.  # noqa: E501

        :param associated_cloud_account_ids: The associated_cloud_account_ids of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: list[str]
        """

        self._associated_cloud_account_ids = associated_cloud_account_ids

    @property
    def accept_self_signed_certificate(self):
        """Gets the accept_self_signed_certificate of this CloudaccountsnsxtIdBody.  # noqa: E501

        Accept self signed certificate when connecting.  # noqa: E501

        :return: The accept_self_signed_certificate of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: bool
        """
        return self._accept_self_signed_certificate

    @accept_self_signed_certificate.setter
    def accept_self_signed_certificate(self, accept_self_signed_certificate):
        """Sets the accept_self_signed_certificate of this CloudaccountsnsxtIdBody.

        Accept self signed certificate when connecting.  # noqa: E501

        :param accept_self_signed_certificate: The accept_self_signed_certificate of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: bool
        """

        self._accept_self_signed_certificate = accept_self_signed_certificate

    @property
    def tags(self):
        """Gets the tags of this CloudaccountsnsxtIdBody.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :return: The tags of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CloudaccountsnsxtIdBody.

        A set of tag keys and optional values to set on the Cloud Account  # noqa: E501

        :param tags: The tags of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def certificate_info(self):
        """Gets the certificate_info of this CloudaccountsnsxtIdBody.  # noqa: E501


        :return: The certificate_info of this CloudaccountsnsxtIdBody.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this CloudaccountsnsxtIdBody.


        :param certificate_info: The certificate_info of this CloudaccountsnsxtIdBody.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudaccountsnsxtIdBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudaccountsnsxtIdBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
